<template>
  <v-list v-if="seat.pax && !insertPax">
    <v-list-item v-if="availablePaxs && availablePaxs.length > 0" data-cy="SeatPlaceInsertPaxBtn"
      @click="insertPax = true">
      <v-list-item-title>Insérer un passager</v-list-item-title>
    </v-list-item>
    <v-list-item data-cy="SeatPlaceMovePaxBtn" @click="movePax()">
      <v-list-item-title>Déplacer le passager</v-list-item-title>
    </v-list-item>
  </v-list>
  <v-card v-else class="seat-place-card" width="400px" max-height="450px">
    <v-card-title class="font-weight-bold text-subtitle-1">
      {{ seat.number }}{{ seat.row }} Passagers non placés
    </v-card-title>
    <v-card-text>
      <v-divider class="mb-2"></v-divider>
      <div v-if="!availablePaxs || availablePaxs.length < 1">
        Tout les passagers sont placés
      </div>
      <v-list rounded density="compact" v-else>
        <v-list-item-group v-model="paxToPlaceIndex">
          <v-list-item v-for="pax in availablePaxs" :key="pax.id">
            <template #default="{ active }">
              <v-list-item-action>
                <v-checkbox data-cy="SeatPlaceSelectPaxCheckbox" :input-value="active"></v-checkbox>
              </v-list-item-action>

              <v-list-item-content>
                <v-list-item-title>{{ pax.rank ? pax.rank.name : '' }} {{ pax.lastName }} {{ pax.firstName
                  }}</v-list-item-title>
              </v-list-item-content>
            </template>
          </v-list-item>
        </v-list-item-group>
      </v-list>
    </v-card-text>
    <v-card-actions>
      <v-spacer></v-spacer>
      <v-btn variant="outlined" class="text-uppercase" rounded size="large" @click="close()">
        Annuler
      </v-btn>
      <v-btn class="text-uppercase inverted" variant="outlined" rounded size="large" data-cy="SeatPlacePlacePaxBtn"
        :disabled="!paxToPlaceIndex && paxToPlaceIndex !== 0" @click="placePax()">
        Valider
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script setup lang="ts">
import { Seat } from "~/dto/seat.dto";
import { Pax } from "~/dto/pax.dto";

const props = defineProps<{
  seat: Seat,
  availablePaxs: Pax[]
}>();

const emit = defineEmits(['movePax', 'placePax', 'close']);

const insertPax = ref(false);

const paxToPlaceIndex: Ref<number | null> = ref(null);
const movePax = () => {
  emit('movePax', props.seat.pax);
  close();
}

const close = () => {
  emit('close');
}

const placePax = () => {
  if (paxToPlaceIndex.value === null) {
    return;
  }
  const pax = props.availablePaxs[paxToPlaceIndex.value];
  if (!pax) {
    return;
  }
  emit('placePax', pax);
  close();
}

</script>

<style lang="scss">
@import "../../../../assets/variables.scss";

.seat-place-card {
  .v-card__text {
    max-height: 330px;
    overflow: auto;
  }

  .v-list .v-list-item {
    &:not(:last-child):not(:only-child) {
      margin: 0;
    }

    &__action {
      margin: 0 32px 0 0;
    }
  }
}
</style>
